package org.example.SnakeGame;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.Pane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.util.Random;

public class SnakeGame extends Application {

    private final static Logger logger = LogManager.getLogger(SnakeGame.class);
    private static final int radius = 5;
    private static final int step = 8;

    //food
    private Circle food;
    private Random random;
    private Pane root;
    private Circle snake;

    /** methode will create the food
     * and display it randomly **/
    private void newFood(){
    food = new Circle(random.nextInt(598),random.nextInt(498), radius);
    food.setFill(Color.RED);
    root.getChildren().add(food);
    }

    private void newSnake(){
        snake = new Circle(300,250, radius+2);
        root.getChildren().add(snake);
    }
     @Override
    public void start (Stage primaryStage) {

        root = new Pane();
        root.setPrefSize(600, 500);
        random = new Random();

        newFood();
        newSnake();
        Scene scene = new Scene(root);

        scene.addEventFilter(KeyEvent.KEY_PRESSED, event -> {
                KeyCode code = event.getCode();
                if (code == KeyCode.UP){
                    snake.setCenterY(snake.getCenterY()- step);
                }
                else if (code == KeyCode.DOWN){
                    snake.setCenterY(snake.getCenterY() + step);
                }
                else if (code == KeyCode.LEFT) {
                    snake.setCenterX(snake.getCenterX() - step);
                }
                else if (code == KeyCode.RIGHT) {
                    snake.setCenterX(snake.getCenterX() + step);
                }
     });

        primaryStage.setTitle("Snake Game");
        primaryStage.setScene(scene);
        primaryStage.setResizable(false);
        primaryStage.show();
    }


}
